Bug 99296 - Calc: disable headers/footers by default
Summary: Calc: disable headers/footers by default
Status: NEW
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Calc (show other bugs)
Version:
(earliest affected)
Inherited From OOo
Hardware: All All
: medium enhancement
Assignee: Not Assigned
URL:
Whiteboard: reviewed:2022
Keywords: difficultyInteresting, easyHack, skillCpp, topicUI
: 120876 121637 122492 (view as bug list)
Depends on:
Blocks: Calc-Header-Footer
  Show dependency treegraph
 
Reported: 2016-04-14 13:44 UTC by Samuel Mehrbrodt (allotropia)
Modified: 2022-07-19 13:25 UTC (History)
16 users (show)

See Also:
Crash report or crash signature:
Regression By:


Attachments
Default calc document printed (7.34 KB, image/png)
2016-04-14 13:49 UTC, Samuel Mehrbrodt (allotropia)
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Samuel Mehrbrodt (allotropia) 2016-04-14 13:44:49 UTC
Currently Calc has the table name in the header and the page name in the footer by default (see attachment).

This looks kind of weird if you do not change the table name ("Table1" by default) and have only one page to print.

I suggest to remove this default and have blank headers&footers by default.
Comment 1 Samuel Mehrbrodt (allotropia) 2016-04-14 13:49:41 UTC
Created attachment 124341 [details]
Default calc document printed
Comment 2 sophie 2016-04-14 14:49:54 UTC
+1 set as New - Sophie
Comment 3 Katarina Behrens (Inactive) 2016-04-14 14:50:20 UTC
<jphilipz> bubli_, mahfiaz, sophi: samuel_m thinks we should have blank header and footer by default in calc #99296
<bubli_> jphilipz: Yes he said so already :))
<bubli_> and I told him it makes kinda sense
<bubli_> It's slightly unexpected when one prints a sheet and has a header and footer there
<bubli_> without actively doing anything to set those
<jphilipz> bubli_, sophi: please comment in the bug report with your approval :D

+1 then
Comment 4 Cor Nouws 2016-04-14 19:27:40 UTC
(In reply to Samuel Mehrbrodt (CIB) from comment #0)
> Currently Calc has the table name in the header and the page name in the
> footer by default (see attachment).

Page number in the footer.

> This looks kind of weird if you do not change the table name ("Table1" by
> default) and have only one page to print.
> 
> I suggest to remove this default and have blank headers&footers by default.

Could that be suppressed for the case with one page?
For more pages, it's not that weird and helps people.
Comment 5 Samuel Mehrbrodt (allotropia) 2016-04-15 08:36:11 UTC
(In reply to Cor Nouws from comment #4)
> Could that be suppressed for the case with one page?
> For more pages, it's not that weird and helps people.

Calc doesn't support different header/footer for the first page, implementing that is out of scope here.
Comment 6 Samuel Mehrbrodt (allotropia) 2016-04-15 08:37:20 UTC
One problem with just removing the default content:

The header/footer is still there (taking space when printing), it just has no content. So we should also disable the header/footer in the page style.

The question is, should we then leave the default content in and just disable them by default, or disable and remove default content?
Comment 7 Yousuf Philips (jay) (retired) 2016-04-15 16:32:36 UTC
So i checked Excel 2003, Quattro Pro x7, Calligra Words, and WPS Spreadsheet and none of them had anything in the header and footer by default. The only app that did have something was Gnumeric, which had the sheet name in the header and the page number in the footer similar to LibreOffice.

As we dont have anything by default in the header and footer in new documents from Writer or Impress, it would be consistent to do the same in new Calc documents.

(In reply to Samuel Mehrbrodt (CIB) from comment #6)
> The question is, should we then leave the default content in and just
> disable them by default, or disable and remove default content?

Well i was going to suggest that you disable them in the page style and leave the presets in, but the problem is that when they are disable, Insert > Header and Footer is them disabled and a user would have to know to go into the page style dialog in order to enable them. If it is possible to always have 'Header and Footer' enabled and the dialog has the ability to enable and disable header and footer as well as modify them, that would likely be the best option.
Comment 8 Heiko Tietze 2016-04-29 12:26:15 UTC
Design team decided to disable header/footer by default.
Comment 9 Roman Kuznetsov 2018-06-11 11:34:34 UTC
(In reply to Heiko Tietze from comment #8)
> Design team decided to disable header/footer by default.

+100500

is it hard to make?
Comment 10 Commit Notification 2018-09-03 07:06:47 UTC
heiko tietze committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=08b5048198d59441cb8033ed14cd17e68c943004

tdf#99296 - Disable headers/footers by default

It will be available in 6.2.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 11 Cor Nouws 2018-09-04 21:11:38 UTC
(In reply to Samuel Mehrbrodt (CIB) from comment #5)
> (In reply to Cor Nouws from comment #4)
> > Could that be suppressed for the case with one page?
> > For more pages, it's not that weird and helps people.
> 
> Calc doesn't support different header/footer for the first page,
> implementing that is out of scope here.

True - but if different sheets (with print ranges..) have a different page style, it is within reach.
Comment 12 BogdanB 2018-09-15 11:34:53 UTC
I checked on Linux 6.2: this bug is solved.

Version: 6.2.0.0.alpha0+
Build ID: 9a9b81c7212fa6a6762246593acf3f1950677a22
CPU threads: 4; OS: Linux 4.15; UI render: GL; VCL: gtk2; 
TinderBox: Linux-rpm_deb-x86_64@86-TDF, Branch:master, Time: 2018-09-08_00:00:43
Locale: ro-RO (ro_RO.UTF-8); Calc: threaded
Comment 13 Xisco Faulí 2018-10-24 15:33:13 UTC
*** Bug 120876 has been marked as a duplicate of this bug. ***
Comment 14 Heiko Tietze 2018-12-06 16:13:25 UTC
Patch reverted.
Comment 15 Commit Notification 2018-12-07 07:41:47 UTC
Heiko Tietze committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/+/d08e63fb1ab16d96e3d1404c4b82267447104a0f%5E%21

tdf#121759 Revert "tdf#99296 - Disable headers/footers by default"

It will be available in 6.3.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 16 Commit Notification 2018-12-07 19:30:24 UTC
Heiko Tietze committed a patch related to this issue.
It has been pushed to "libreoffice-6-2":

https://git.libreoffice.org/core/+/1d3a07415eda3014d67d7c56466a8ad1d0ec51d9%5E%21

tdf#121759 Revert "tdf#99296 - Disable headers/footers by default"

It will be available in 6.2.0.1.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 17 Xisco Faulí 2018-12-10 16:47:44 UTC Comment hidden (obsolete)
Comment 18 Roman Kuznetsov 2018-12-10 18:17:07 UTC
(In reply to Xisco Faulí from comment #17)
> (In reply to Heiko Tietze from comment #14)
> > Patch reverted.
> 
> Hi Heiko,
> Out of curiosity, why this patch got reverted ?

See bug 121759
Comment 19 Heiko Tietze 2019-01-02 11:31:23 UTC
*** Bug 121637 has been marked as a duplicate of this bug. ***
Comment 20 Heiko Tietze 2019-01-02 11:39:09 UTC
Since it was requested again in bug 121637 here is where we are:
Patch https://gerrit.libreoffice.org/#/c/59696/ disables the header/footer by default but then we run into trouble with the menu item Insert > Header and Footer... for editing. Patch https://gerrit.libreoffice.org/#/c/64712/ disables this menu item until Header/Footer are checked at Format > Page > Header/Footer (and moves the menu entry to Edit for clarification). But this solution was not accepted as an improvement since users do not know how to enable it. See http://document-foundation-mail-archive.969070.n3.nabble.com/Re-Minutes-from-the-UX-design-meeting-2018-Dec-06-tc4254107.html#a4254112 for the discussion. So eventually both patches got reverted.
Comment 21 Xisco Faulí 2019-01-17 11:44:40 UTC
*** Bug 122492 has been marked as a duplicate of this bug. ***
Comment 22 Roman Kuznetsov 2019-07-24 14:24:06 UTC
Heiko, I suggest merge back your patch disabling header/footer by default.

For solution of the problem with "Insert->Headers and Footers" menu item I suggest follow variants for discuss:

1. Just delete menu item Insert->Headers and Footers at all and update guides and Help.
2. Insert->Headers and Footers should be split to two menu items Insert->Header and Insert->Footer that will be open Format->Page dialog on Header and Footer tabs and will activate options "Header on" / "Footer on" respectively.

I think disabling of Headers/Footers by default is more important and useful  thing than disabled "Insert->Headers and Footers" menu item that btw. has workaround.
Comment 23 Heiko Tietze 2019-07-24 15:33:30 UTC Comment hidden (obsolete)
Comment 24 Samuel Mehrbrodt (allotropia) 2019-07-25 08:30:07 UTC Comment hidden (obsolete)
Comment 25 Roman Kuznetsov 2019-07-25 09:33:46 UTC
(In reply to Samuel Mehrbrodt (CIB) from comment #24)
> (In reply to Roman Kuznetsov from comment #22)
> > 1. Just delete menu item Insert->Headers and Footers at all and update
> > guides and Help.
> > 2. Insert->Headers and Footers should be split to two menu items
> > Insert->Header and Insert->Footer that will be open Format->Page dialog on
> > Header and Footer tabs and will activate options "Header on" / "Footer on"
> > respectively.
> > 
> 
> How are users then supposed to edit header and footer content?

User will press the Edit button on Header/Footer tab in the Page dialog and he will see the same Header (Footer) dialog as from Instert->Headers and Footers now.

btw, if I disable header and footer in the Page dialog then Instert->Headers and Footers disabled also and I can't use it directly.
Comment 26 Samuel Mehrbrodt (allotropia) 2019-07-25 12:14:58 UTC
Ok, sounds reasonable then.

But the UX improvements should be done *before* disabling header/footer by default.

* Create two new menu entries Insert->Header / Insert->Footer which open the Page dialog in the respective tab
* Also the "Edit" button in the Header/Footer tab in the page style dialog is a bit hidden (I never noticed it). It should have a clearer label (e.g. "Edit header/footer content") and probably be placed directly under the "Enable Header" checkbox. Maybe the content below could be separated by a heading "More options" or something.
Comment 27 Cor Nouws 2019-07-25 19:15:19 UTC
(In reply to Roman Kuznetsov from comment #22)

> 2. Insert->Headers and Footers should be split to two menu items
> Insert->Header and Insert->Footer that will be open Format->Page dialog on
> Header and Footer tabs and will activate options "Header on" / "Footer on"
> respectively.
Good idea.

(In reply to Roman Kuznetsov from comment #25)
> (In reply to Samuel Mehrbrodt (CIB) from comment #24)
> > How are users then supposed to edit header and footer content?
> 
> User will press the Edit button on Header/Footer tab in the Page dialog and
> he will see the same Header (Footer) dialog as from Instert->Headers and
> Footers now.
And I wouldn't be surprised if the same menu opens the dialog always, allowing the user to click Edit for existing header/footers.

(though it feels a bit inconsistent compared to other functions that have both insert and edit in the menu..)

> btw, if I disable header and footer in the Page dialog then Instert->Headers
> and Footers disabled also and I can't use it directly.
That doesn't seem logic to me..
Comment 28 Heiko Tietze 2019-08-14 07:57:18 UTC
(In reply to Samuel Mehrbrodt (CIB) from comment #26)
> * Create two new menu entries...

(In reply to Cor Nouws from comment #27)
> (In reply to Roman Kuznetsov from comment #22)
> 
> > 2. Insert->Headers and Footers should be split to two menu items
> Good idea.

Why don't you consider Roman's option #1, to remove Insert > Header and Footer...? 

Some arguments: 
* In Calc you insert or edit spreadsheets not the printout where h/f would be added. 
* Adding more and more items to the menu bloats it further. 
* Insert is not the right place for editing, which is the actual operation. Moving it to Edit means you have to go to Format > Page to enable - or you insert via Edit.
Comment 29 Heiko Tietze 2019-08-14 08:37:07 UTC
Here is the patch for open #1: https://gerrit.libreoffice.org/#/c/77445/
Comment 30 Roman Kuznetsov 2019-08-14 09:14:52 UTC
(In reply to Heiko Tietze from comment #28)
> (In reply to Samuel Mehrbrodt (CIB) from comment #26)
> > * Create two new menu entries...
> 
> (In reply to Cor Nouws from comment #27)
> > (In reply to Roman Kuznetsov from comment #22)
> > 
> > > 2. Insert->Headers and Footers should be split to two menu items
> > Good idea.
> 
> Why don't you consider Roman's option #1, to remove Insert > Header and
> Footer...? 
> 
> Some arguments: 
> * In Calc you insert or edit spreadsheets not the printout where h/f would
> be added. 
> * Adding more and more items to the menu bloats it further. 
> * Insert is not the right place for editing, which is the actual operation.
> Moving it to Edit means you have to go to Format > Page to enable - or you
> insert via Edit.

Because there are two menu item Insert Header and Insert Footer in Writer? And user will expect the same opportunity in Calc?
Comment 31 Cor Nouws 2019-08-18 20:04:52 UTC
(In reply to Roman Kuznetsov from comment #30)
> Because there are two menu item Insert Header and Insert Footer in Writer?
> And user will expect the same opportunity in Calc?
Indeed.

I've never been a fan of removing the h/f by default as is done now. And see really not a single advantage in making it harder to start inserting/editing them.
Comment 32 Heiko Tietze 2019-08-22 11:49:12 UTC
We discussed this on IRC and Telegram. While I', in favor of a solution without entries in the main menu, Samuel, Bogdan and Kompilainnen voted for having two entries, Insert > ? > Header/Footer (or maybe just Insert > Header and Footer) that always open the dialog, with the argument that novice will search for it there instead of the page properties. Will see what I can do.
Comment 33 Heiko Tietze 2019-09-24 13:13:18 UTC
It's pretty simple to add exclude testing of ( !m_bHeaderOn && !m_bFooterOn ) in ScDocShell::GetStatePageStyle() sc/source/ui/docshell/docsh4.cxx and to add checkboxes to the dialog which are assigned at ScHFEditPage::ScHFEditPage() sc/source/ui/pagedlg/scuitphfedit.cxx with

    const bool bOn = rCoreAttrs.Get( bHeader ? ATTR_PAGE_HEADERSET : ATTR_PAGE_FOOTERSET ).GetItemSet().Get( ATTR_PAGE_ON ).GetValue();
    m_xEnableHF->set_active( bOn );
    m_xEnableHF->set_label(m_xEnableHF->get_label() + " " + m_xFtDefinedHF->get_label());

but then the trouble begins. The dialog is heavily overloaded and tabs are show or not depending on many conditions. So unassigning myself to save time for other tasks.
Comment 34 Timur 2021-08-30 07:11:55 UTC
This is one of changes that will never be correct because of different needs. 
I'm not in favor of changing any such defaults.
So please, do *not* change default behavior, but introduce an *option* in Calc -View? that user may set header and (separately) footer off.
Comment 35 Roman Kuznetsov 2021-08-30 07:37:35 UTC
(In reply to Timur from comment #34)
> This is one of changes that will never be correct because of different
> needs. 
> I'm not in favor of changing any such defaults.
> So please, do *not* change default behavior, but introduce an *option* in
> Calc -View? that user may set header and (separately) footer off.

Timur, today we have enabled Header/Footer by default! User doesn't expect it. User can enable Header/Footer when HE/SHE want to print the spreadsheet.
Comment 36 Roeland 2021-08-30 19:24:38 UTC
(In reply to Roman Kuznetsov from comment #35)
> (In reply to Timur from comment #34)
> > This is one of changes that will never be correct because of different
> > needs. 
> > I'm not in favor of changing any such defaults.
> > So please, do *not* change default behavior, but introduce an *option* in
> > Calc -View? that user may set header and (separately) footer off.
> 
> Timur, today we have enabled Header/Footer by default! User doesn't expect
> it. User can enable Header/Footer when HE/SHE want to print the spreadsheet.

Yes, it's always a surprise for the user when "page one" suddenly gets printed on their documents.

This header/footer is per default set as on. There's no way to know this until you print/export your fist spreadsheet, whereafter the search begins why these words are included.

This is not wysiwyg behaviour. It’s always a search for new people how to remove these (possibly unwanted) words.
Comment 37 Timur 2021-08-31 08:20:13 UTC
Some general principles:
- it's wrong to change behavior based on some opinions when others will have different needs, so any discussion in that direction is not useful;
- solution is to make an option for default behavior of new sheets, and that user may save specific sheet setting (default and specific setting);
- I'm not in favor of changing default behavior (of having header) but it doesn't matter much as long as there's an option;
- there'a bug 144056 to be also able to turn off headers once when using commandline. 

Due to users and duplicates, I think this is of High importance (relative to other enhancement requests, of which some are highest and some lower).
Comment 38 Roman Kuznetsov 2021-08-31 08:48:36 UTC
Timur, Writer doesn't have header/footer by default. Why Calc should have it by default? MS Excel doesn't have it, OnlyOffice Tables doesn't have it too.
Comment 39 Samuel Mehrbrodt (allotropia) 2021-08-31 09:00:33 UTC
(In reply to Timur from comment #37)
> - solution is to make an option for default behavior of new sheets, and that
> user may save specific sheet setting (default and specific setting);
> - I'm not in favor of changing default behavior (of having header) but it
> doesn't matter much as long as there's an option;

Yes, the whole point of this request is to change the default, so only new documents will be affected anyway.
Header/Footer settings are saved to the document, so headers/footers won't be removed from existing documents.
Comment 40 Mike Kaganski 2022-05-26 08:12:13 UTC
(In reply to Timur from comment #37)

There is no need to introduce options for what is already configurable and flexible.

We have a concept of templates, and an option to make some template the default. So for this issue:

1. It makes sense to change the *application default* (i.e., when no templates are used = how the program behaves on a clean install) to something that matches *most* user expectations, without any new options introduced (and appreciating that some users might indeed like the old behavior better);
2. Everyone who prefers to have headers/footers in newly created documents should do that exactly like any other customization of newly created documents is performed: using custom default template.

(That said, I do not know what is the predominant user expectation here, and I don't care about this - just commented on the "Some general principles".)